# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`splunk`](#splunk): This class is unused and doesn't do anything but make default data
accessible
* [`splunk::enterprise`](#splunk--enterprise): Install and configure an instance of Splunk Enterprise
* [`splunk::enterprise::config`](#splunk--enterprise--config): Private class declared by Class[splunk::enterprise] to contain all the
configuration needed for a base install of Splunk Enterprise
* [`splunk::enterprise::install`](#splunk--enterprise--install): Private class declared by Class[splunk::enterprise] to contain or define
through additional platform specific sub-class, the required steps
for successfully installing Splunk Enterprise
* [`splunk::enterprise::install::nix`](#splunk--enterprise--install--nix): Private class declared by Class[splunk::enterprise::install] to provide
platform specific installation steps on Linux or Unix type systems.
* [`splunk::enterprise::password::manage`](#splunk--enterprise--password--manage): Implements the direct management of the Splunk Enterprise admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans.

Note: Entirely done to make this implementation consistent with the method
used to manage admin password seeding.
* [`splunk::enterprise::password::seed`](#splunk--enterprise--password--seed): Implements the seeding and reseeding of the Splunk Enterprise admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans
* [`splunk::enterprise::service`](#splunk--enterprise--service): Private class declared by Class[splunk::enterprise] to define a service
as its understood by Puppet using a dynamic set of data or platform specific
sub-classes
* [`splunk::enterprise::service::nix`](#splunk--enterprise--service--nix): Private class declared by Class[splunk::enterprise::service] to provide
platform specific service management on Linux or Unix type systems.
* [`splunk::forwarder`](#splunk--forwarder): Install and configure an instance of Splunk Universal Forwarder
* [`splunk::forwarder::config`](#splunk--forwarder--config): Private class declared by Class[splunk::forwarder] to contain all the
configuration needed for a base install of the Splunk Universal
Forwarder
* [`splunk::forwarder::install`](#splunk--forwarder--install): Private class declared by Class[splunk::forwarder] to contain or define
through additional platform specific sub-class, the required steps
for successfully installing the Splunk Universal Forwarder
* [`splunk::forwarder::password::manage`](#splunk--forwarder--password--manage): Implements the direct management of the Splunk Forwarder admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans.

Note: Entirely done to make this implementation consistent with the method
used to manage admin password seeding.
* [`splunk::forwarder::password::seed`](#splunk--forwarder--password--seed): Implements the seeding and reseeding of the Splunk Forwarder admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans
* [`splunk::forwarder::service`](#splunk--forwarder--service): Private class declared by Class[splunk::forwarder] to define a service as
its understood by Puppet using a dynamic set of data or platform specific
sub-classes
* [`splunk::forwarder::service::nix`](#splunk--forwarder--service--nix): Private class declared by Class[splunk::forwarder::service] to provide
platform specific service management on Linux or Unix type systems.
* [`splunk::params`](#splunk--params): This class takes a small number of arguments (can be set through Hiera) and
generates sane default values installation media names and locations.
Default ports can also be specified here. This is a parameters class, and
contributes no resources to the graph. Rather, it only sets values for
parameters to be consumed by child classes.

### Defined types

* [`splunk::addon`](#splunk--addon): Defined type for deploying Splunk Add-ons and Apps from either OS packages
or via splunkbase compatible archives

### Resource types

* [`splunk_alert_actions`](#splunk_alert_actions): Manage splunk alert_actions settings in alert_actions.conf
* [`splunk_authentication`](#splunk_authentication): Manage splunk authentication settings in authentication.conf
* [`splunk_authorize`](#splunk_authorize): Manage splunk authorize settings in authorize.conf
* [`splunk_config`](#splunk_config): splunk config
* [`splunk_deploymentclient`](#splunk_deploymentclient): Manage splunk deploymentclient entries in deploymentclient.conf
* [`splunk_distsearch`](#splunk_distsearch): Manage distsearch entries in distsearch.conf
* [`splunk_indexes`](#splunk_indexes): Manage splunk index settings in indexes.conf
* [`splunk_input`](#splunk_input): Manage splunk input settings in inputs.conf
* [`splunk_limits`](#splunk_limits): Manage splunk limits settings in limits.conf
* [`splunk_metadata`](#splunk_metadata): Manage metadata entries in {default,local}.meta
* [`splunk_output`](#splunk_output): Manage splunk output settings in outputs.conf
* [`splunk_props`](#splunk_props): Manage splunk prop settings in props.conf
* [`splunk_server`](#splunk_server): Manage splunk server settings in server.conf
* [`splunk_serverclass`](#splunk_serverclass): Manage splunk serverclass entries in serverclass.conf
* [`splunk_transforms`](#splunk_transforms): Manage splunk transforms settings in transforms.conf
* [`splunk_uiprefs`](#splunk_uiprefs): Manage splunk web ui settings in ui-prefs.conf
* [`splunk_web`](#splunk_web): Manage splunk web settings in web.conf
* [`splunkforwarder_deploymentclient`](#splunkforwarder_deploymentclient): Manage splunkforwarder deploymentclient entries in deploymentclient.conf
* [`splunkforwarder_input`](#splunkforwarder_input): Manage splunkforwarder input settings in inputs.conf
* [`splunkforwarder_limits`](#splunkforwarder_limits): Manage splunkforwarder limit settings in limits.conf
* [`splunkforwarder_output`](#splunkforwarder_output): Manage splunkforwarder output settings in outputs.conf
* [`splunkforwarder_props`](#splunkforwarder_props): Manage splunkforwarder props settings in props.conf
* [`splunkforwarder_server`](#splunkforwarder_server): Manage splunkforwarder server settings in server.conf
* [`splunkforwarder_transforms`](#splunkforwarder_transforms): Manage splunkforwarder transforms settings in transforms.conf
* [`splunkforwarder_web`](#splunkforwarder_web): Manage splunkforwarder web settings in web.conf

### Data types

* [`Splunk::Entinstalloptions`](#Splunk--Entinstalloptions)
* [`Splunk::Fwdinstalloptions`](#Splunk--Fwdinstalloptions)

## Classes

### <a name="splunk"></a>`splunk`

This class is unused and doesn't do anything but make default data
accessible

* **Note** If you were expecting this class to setup an instance of Splunk
Enterprise then please look to Class[splunk::enterprise].

### <a name="splunk--enterprise"></a>`splunk::enterprise`

Install and configure an instance of Splunk Enterprise

#### Examples

##### Basic usage

```puppet
include splunk::enterprise
```

##### Install specific version and build with admin passord management

```puppet
class { 'splunk::params':
  version => '7.2.5',
  build   => '088f49762779',
}
class { 'splunk::enterprise':
  package_ensure => latest,
  manage_password => true,
}
```

#### Parameters

The following parameters are available in the `splunk::enterprise` class:

* [`version`](#-splunk--enterprise--version)
* [`package_name`](#-splunk--enterprise--package_name)
* [`package_ensure`](#-splunk--enterprise--package_ensure)
* [`staging_dir`](#-splunk--enterprise--staging_dir)
* [`path_delimiter`](#-splunk--enterprise--path_delimiter)
* [`enterprise_package_src`](#-splunk--enterprise--enterprise_package_src)
* [`package_provider`](#-splunk--enterprise--package_provider)
* [`manage_package_source`](#-splunk--enterprise--manage_package_source)
* [`package_source`](#-splunk--enterprise--package_source)
* [`install_options`](#-splunk--enterprise--install_options)
* [`splunk_user`](#-splunk--enterprise--splunk_user)
* [`enterprise_homedir`](#-splunk--enterprise--enterprise_homedir)
* [`enterprise_confdir`](#-splunk--enterprise--enterprise_confdir)
* [`service_name`](#-splunk--enterprise--service_name)
* [`service_file`](#-splunk--enterprise--service_file)
* [`boot_start`](#-splunk--enterprise--boot_start)
* [`use_default_config`](#-splunk--enterprise--use_default_config)
* [`input_default_host`](#-splunk--enterprise--input_default_host)
* [`input_connection_host`](#-splunk--enterprise--input_connection_host)
* [`splunkd_listen`](#-splunk--enterprise--splunkd_listen)
* [`logging_port`](#-splunk--enterprise--logging_port)
* [`splunkd_port`](#-splunk--enterprise--splunkd_port)
* [`web_httpport`](#-splunk--enterprise--web_httpport)
* [`purge_inputs`](#-splunk--enterprise--purge_inputs)
* [`purge_outputs`](#-splunk--enterprise--purge_outputs)
* [`purge_authentication`](#-splunk--enterprise--purge_authentication)
* [`purge_authorize`](#-splunk--enterprise--purge_authorize)
* [`purge_distsearch`](#-splunk--enterprise--purge_distsearch)
* [`purge_indexes`](#-splunk--enterprise--purge_indexes)
* [`purge_limits`](#-splunk--enterprise--purge_limits)
* [`purge_props`](#-splunk--enterprise--purge_props)
* [`purge_server`](#-splunk--enterprise--purge_server)
* [`purge_transforms`](#-splunk--enterprise--purge_transforms)
* [`purge_web`](#-splunk--enterprise--purge_web)
* [`manage_password`](#-splunk--enterprise--manage_password)
* [`seed_password`](#-splunk--enterprise--seed_password)
* [`reset_seeded_password`](#-splunk--enterprise--reset_seeded_password)
* [`password_config_file`](#-splunk--enterprise--password_config_file)
* [`seed_config_file`](#-splunk--enterprise--seed_config_file)
* [`seed_user`](#-splunk--enterprise--seed_user)
* [`password_content`](#-splunk--enterprise--password_content)
* [`password_hash`](#-splunk--enterprise--password_hash)
* [`secret_file`](#-splunk--enterprise--secret_file)
* [`secret`](#-splunk--enterprise--secret)
* [`purge_alert_actions`](#-splunk--enterprise--purge_alert_actions)
* [`purge_deploymentclient`](#-splunk--enterprise--purge_deploymentclient)
* [`purge_serverclass`](#-splunk--enterprise--purge_serverclass)
* [`purge_uiprefs`](#-splunk--enterprise--purge_uiprefs)

##### <a name="-splunk--enterprise--version"></a>`version`

Data type: `String[1]`

Specifies the version of Splunk Enterprise the module should install and
manage.

Default value: `$splunk::params::version`

##### <a name="-splunk--enterprise--package_name"></a>`package_name`

Data type: `String[1]`

The name of the package(s) Puppet will use to install Splunk.

Default value: `$splunk::params::enterprise_package_name`

##### <a name="-splunk--enterprise--package_ensure"></a>`package_ensure`

Data type: `String[1]`

Ensure parameter which will get passed to the Splunk package resource.

Default value: `$splunk::params::enterprise_package_ensure`

##### <a name="-splunk--enterprise--staging_dir"></a>`staging_dir`

Data type: `String[1]`

Root of the archive path to host the Splunk package.

Default value: `$splunk::params::staging_dir`

##### <a name="-splunk--enterprise--path_delimiter"></a>`path_delimiter`

Data type: `String[1]`

The path separator used in the archived path of the Splunk package.

Default value: `$splunk::params::path_delimiter`

##### <a name="-splunk--enterprise--enterprise_package_src"></a>`enterprise_package_src`

Data type: `String[1]`

The source URL for the splunk installation media (typically an RPM, MSI,
etc). If a `$src_root` parameter is set in splunk::params, this will be
automatically supplied. Otherwise it is required. The URL can be of any
protocol supported by the pupept/archive module. On Windows, this can be
a UNC path to the MSI.

Default value: `$splunk::params::enterprise_package_src`

##### <a name="-splunk--enterprise--package_provider"></a>`package_provider`

Data type: `Optional[String[1]]`

The package management system used to host the Splunk packages.

Default value: `$splunk::params::package_provider`

##### <a name="-splunk--enterprise--manage_package_source"></a>`manage_package_source`

Data type: `Boolean`

Whether or not to use the supplied `enterprise_package_src` param.

Default value: `true`

##### <a name="-splunk--enterprise--package_source"></a>`package_source`

Data type: `Optional[String[1]]`

*Optional* The source URL for the splunk installation media (typically an RPM,
MSI, etc). If `enterprise_package_src` parameter is set in splunk::params and
`manage_package_source` is true, this will be automatically supplied. Otherwise
it is required. The URL can be of any protocol supported by the puppet/archive
module. On Windows, this can be a UNC path to the MSI.

Default value: `undef`

##### <a name="-splunk--enterprise--install_options"></a>`install_options`

Data type: `Splunk::Entinstalloptions`

This variable is passed to the package resources' *install_options* parameter.

Default value: `$splunk::params::enterprise_install_options`

##### <a name="-splunk--enterprise--splunk_user"></a>`splunk_user`

Data type: `String[1]`

The user to run Splunk as.

Default value: `$splunk::params::splunk_user`

##### <a name="-splunk--enterprise--enterprise_homedir"></a>`enterprise_homedir`

Data type: `Stdlib::Absolutepath`

Specifies the Splunk Enterprise home directory.

Default value: `$splunk::params::enterprise_homedir`

##### <a name="-splunk--enterprise--enterprise_confdir"></a>`enterprise_confdir`

Data type: `Stdlib::Absolutepath`

Specifies the Splunk Enterprise configuration directory.

Default value: `$splunk::params::enterprise_confdir`

##### <a name="-splunk--enterprise--service_name"></a>`service_name`

Data type: `String[1]`

The name of the Splunk Enterprise service.

Default value: `$splunk::params::enterprise_service`

##### <a name="-splunk--enterprise--service_file"></a>`service_file`

Data type: `Stdlib::Absolutepath`

The path to the Splunk Enterprise service file.

Default value: `$splunk::params::enterprise_service_file`

##### <a name="-splunk--enterprise--boot_start"></a>`boot_start`

Data type: `Boolean`

Whether or not to enable splunk boot-start, which generates a service file to
manage the Splunk Enterprise service.

Default value: `$splunk::params::boot_start`

##### <a name="-splunk--enterprise--use_default_config"></a>`use_default_config`

Data type: `Boolean`

Whether or not the module should manage a default set of Splunk Enterprise
configuration parameters.

Default value: `true`

##### <a name="-splunk--enterprise--input_default_host"></a>`input_default_host`

Data type: `String[1]`

Part of the default config. Sets the `splunk_input` default host.

Default value: `$facts['networking']['fqdn']`

##### <a name="-splunk--enterprise--input_connection_host"></a>`input_connection_host`

Data type: `String[1]`

Part of the default config. Sets the `splunk_input` connection host.

Default value: `'dns'`

##### <a name="-splunk--enterprise--splunkd_listen"></a>`splunkd_listen`

Data type: `Stdlib::IP::Address`

The address on which splunkd should listen.

Default value: `'127.0.0.1'`

##### <a name="-splunk--enterprise--logging_port"></a>`logging_port`

Data type: `Stdlib::Port`

The port to receive TCP logs on.

Default value: `$splunk::params::logging_port`

##### <a name="-splunk--enterprise--splunkd_port"></a>`splunkd_port`

Data type: `Stdlib::Port`

The management port for Splunk.

Default value: `$splunk::params::splunkd_port`

##### <a name="-splunk--enterprise--web_httpport"></a>`web_httpport`

Data type: `Stdlib::Port`

The port on which to service the Splunk Web interface.

Default value: `8000`

##### <a name="-splunk--enterprise--purge_inputs"></a>`purge_inputs`

Data type: `Boolean`

If set to true, inputs.conf will be purged of configuration that is
no longer managed by the `splunk_input` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_outputs"></a>`purge_outputs`

Data type: `Boolean`

If set to true, outputs.conf will be purged of configuration that is
no longer managed by the `splunk_output` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_authentication"></a>`purge_authentication`

Data type: `Boolean`

If set to true, authentication.conf will be purged of configuration
that is no longer managed by the `splunk_authentication` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_authorize"></a>`purge_authorize`

Data type: `Boolean`

If set to true, authorize.conf will be purged of configuration that
is no longer managed by the `splunk_authorize` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_distsearch"></a>`purge_distsearch`

Data type: `Boolean`

If set to true, distsearch.conf will be purged of configuration that
is no longer managed by the `splunk_distsearch` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_indexes"></a>`purge_indexes`

Data type: `Boolean`

If set to true, indexes.conf will be purged of configuration that is
no longer managed by the `splunk_indexes` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_limits"></a>`purge_limits`

Data type: `Boolean`

If set to true, limits.conf will be purged of configuration that is
no longer managed by the `splunk_limits` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_props"></a>`purge_props`

Data type: `Boolean`

If set to true, props.conf will be purged of configuration that is
no longer managed by the `splunk_props` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_server"></a>`purge_server`

Data type: `Boolean`

If set to true, server.conf will be purged of configuration that is
no longer managed by the `splunk_server` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_transforms"></a>`purge_transforms`

Data type: `Boolean`

If set to true, transforms.conf will be purged of configuration that
is no longer managed by the `splunk_transforms` type.

Default value: `false`

##### <a name="-splunk--enterprise--purge_web"></a>`purge_web`

Data type: `Boolean`

If set to true, web.conf will be purged of configuration that is no
longer managed by the `splunk_web type`.

Default value: `false`

##### <a name="-splunk--enterprise--manage_password"></a>`manage_password`

Data type: `Boolean`

If set to true, Manage the contents of splunk.secret and passwd.

Default value: `$splunk::params::manage_password`

##### <a name="-splunk--enterprise--seed_password"></a>`seed_password`

Data type: `Boolean`

If set to true, Manage the contents of splunk.secret and user-seed.conf.

Default value: `$splunk::params::seed_password`

##### <a name="-splunk--enterprise--reset_seeded_password"></a>`reset_seeded_password`

Data type: `Boolean`

If set to true, deletes `password_config_file` to trigger Splunk's password
import process on restart of the Splunk services.

Default value: `$splunk::params::reset_seeded_password`

##### <a name="-splunk--enterprise--password_config_file"></a>`password_config_file`

Data type: `Stdlib::Absolutepath`

Which file to put the password in i.e. in linux it would be
`/opt/splunk/etc/passwd`.

Default value: `$splunk::params::enterprise_password_config_file`

##### <a name="-splunk--enterprise--seed_config_file"></a>`seed_config_file`

Data type: `Stdlib::Absolutepath`

Which file to place the admin password hash in so its imported by Splunk on
restart.

Default value: `$splunk::params::enterprise_seed_config_file`

##### <a name="-splunk--enterprise--seed_user"></a>`seed_user`

Data type: `String[1]`

The local user (usually 'admin') imported by Splunk.

Default value: `$splunk::params::seed_user`

##### <a name="-splunk--enterprise--password_content"></a>`password_content`

Data type: `String[1]`

The hashed password username/details for the user.

Default value: `$splunk::params::password_content`

##### <a name="-splunk--enterprise--password_hash"></a>`password_hash`

Data type: `String[1]`

The hashed password for the admin user.

Default value: `$splunk::params::password_hash`

##### <a name="-splunk--enterprise--secret_file"></a>`secret_file`

Data type: `Stdlib::Absolutepath`

Which file we should put the secret in.

Default value: `$splunk::params::enterprise_secret_file`

##### <a name="-splunk--enterprise--secret"></a>`secret`

Data type: `String[1]`

The secret used to salt the splunk password.

Default value: `$splunk::params::secret`

##### <a name="-splunk--enterprise--purge_alert_actions"></a>`purge_alert_actions`

Data type: `Boolean`



Default value: `false`

##### <a name="-splunk--enterprise--purge_deploymentclient"></a>`purge_deploymentclient`

Data type: `Boolean`



Default value: `false`

##### <a name="-splunk--enterprise--purge_serverclass"></a>`purge_serverclass`

Data type: `Boolean`



Default value: `false`

##### <a name="-splunk--enterprise--purge_uiprefs"></a>`purge_uiprefs`

Data type: `Boolean`



Default value: `false`

### <a name="splunk--enterprise--config"></a>`splunk::enterprise::config`

Private class declared by Class[splunk::enterprise] to contain all the
configuration needed for a base install of Splunk Enterprise

### <a name="splunk--enterprise--install"></a>`splunk::enterprise::install`

Private class declared by Class[splunk::enterprise] to contain or define
through additional platform specific sub-class, the required steps
for successfully installing Splunk Enterprise

### <a name="splunk--enterprise--install--nix"></a>`splunk::enterprise::install::nix`

Private class declared by Class[splunk::enterprise::install] to provide
platform specific installation steps on Linux or Unix type systems.

### <a name="splunk--enterprise--password--manage"></a>`splunk::enterprise::password::manage`

Implements the direct management of the Splunk Enterprise admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans.

Note: Entirely done to make this implementation consistent with the method
used to manage admin password seeding.

#### Parameters

The following parameters are available in the `splunk::enterprise::password::manage` class:

* [`manage_password`](#-splunk--enterprise--password--manage--manage_password)
* [`password_config_file`](#-splunk--enterprise--password--manage--password_config_file)
* [`password_content`](#-splunk--enterprise--password--manage--password_content)
* [`secret_file`](#-splunk--enterprise--password--manage--secret_file)
* [`secret`](#-splunk--enterprise--password--manage--secret)
* [`service`](#-splunk--enterprise--password--manage--service)
* [`mode`](#-splunk--enterprise--password--manage--mode)
* [`splunk_user`](#-splunk--enterprise--password--manage--splunk_user)

##### <a name="-splunk--enterprise--password--manage--manage_password"></a>`manage_password`

Data type: `Boolean`

If set to true, Manage the contents of splunk.secret and passwd.

Default value: `$splunk::params::manage_password`

##### <a name="-splunk--enterprise--password--manage--password_config_file"></a>`password_config_file`

Data type: `Stdlib::Absolutepath`

Which file to put the password in i.e. in linux it would be
`/opt/splunk/etc/passwd`.

Default value: `$splunk::params::forwarder_password_config_file`

##### <a name="-splunk--enterprise--password--manage--password_content"></a>`password_content`

Data type: `String[1]`

The hashed password username/details for the user.

Default value: `$splunk::params::password_content`

##### <a name="-splunk--enterprise--password--manage--secret_file"></a>`secret_file`

Data type: `Stdlib::Absolutepath`

Which file we should put the secret in.

Default value: `$splunk::params::forwarder_secret_file`

##### <a name="-splunk--enterprise--password--manage--secret"></a>`secret`

Data type: `String[1]`

The secret used to salt the splunk password.

Default value: `$splunk::params::secret`

##### <a name="-splunk--enterprise--password--manage--service"></a>`service`

Data type: `String[1]`

Name of the Splunk Enterprise service that needs to be restarted after files
are updated, not applicable when running in agent mode.

Default value: `$splunk::params::enterprise_service`

##### <a name="-splunk--enterprise--password--manage--mode"></a>`mode`

Data type: `Enum['agent', 'bolt']`

The class is designed to work in two ways, as a helper that is called by
Class[splunk::enterprise::config] or leveraged independently from with in a
Bolt Plan. The value defaults to "bolt" implicitly assuming that anytime it
is used outside of Class[splunk::enterprise::config], it is being used by
Bolt

Default value: `'bolt'`

##### <a name="-splunk--enterprise--password--manage--splunk_user"></a>`splunk_user`

Data type: `String[1]`



Default value: `$splunk::params::splunk_user`

### <a name="splunk--enterprise--password--seed"></a>`splunk::enterprise::password::seed`

Implements the seeding and reseeding of the Splunk Enterprise admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans

#### Parameters

The following parameters are available in the `splunk::enterprise::password::seed` class:

* [`reset_seeded_password`](#-splunk--enterprise--password--seed--reset_seeded_password)
* [`password_config_file`](#-splunk--enterprise--password--seed--password_config_file)
* [`seed_config_file`](#-splunk--enterprise--password--seed--seed_config_file)
* [`seed_user`](#-splunk--enterprise--password--seed--seed_user)
* [`password_hash`](#-splunk--enterprise--password--seed--password_hash)
* [`secret_file`](#-splunk--enterprise--password--seed--secret_file)
* [`secret`](#-splunk--enterprise--password--seed--secret)
* [`service`](#-splunk--enterprise--password--seed--service)
* [`mode`](#-splunk--enterprise--password--seed--mode)
* [`splunk_user`](#-splunk--enterprise--password--seed--splunk_user)

##### <a name="-splunk--enterprise--password--seed--reset_seeded_password"></a>`reset_seeded_password`

Data type: `Boolean`

If set to true, deletes `password_config_file` to trigger Splunk's password
import process on restart of the Splunk services.

Default value: `$splunk::params::reset_seeded_password`

##### <a name="-splunk--enterprise--password--seed--password_config_file"></a>`password_config_file`

Data type: `Stdlib::Absolutepath`

Which file to put the password in i.e. in linux it would be
`/opt/splunk/etc/passwd`.

Default value: `$splunk::params::enterprise_password_config_file`

##### <a name="-splunk--enterprise--password--seed--seed_config_file"></a>`seed_config_file`

Data type: `Stdlib::Absolutepath`

Which file to place the admin password hash in so its imported by Splunk on
restart.

Default value: `$splunk::params::enterprise_seed_config_file`

##### <a name="-splunk--enterprise--password--seed--seed_user"></a>`seed_user`

Data type: `String[1]`

The local user (usually 'admin') imported by Splunk.

Default value: `$splunk::params::seed_user`

##### <a name="-splunk--enterprise--password--seed--password_hash"></a>`password_hash`

Data type: `String[1]`

The hashed password for the admin user.

Default value: `$splunk::params::password_hash`

##### <a name="-splunk--enterprise--password--seed--secret_file"></a>`secret_file`

Data type: `Stdlib::Absolutepath`

Which file we should put the secret in.

Default value: `$splunk::params::enterprise_secret_file`

##### <a name="-splunk--enterprise--password--seed--secret"></a>`secret`

Data type: `String[1]`

The secret used to salt the splunk password.

Default value: `$splunk::params::secret`

##### <a name="-splunk--enterprise--password--seed--service"></a>`service`

Data type: `String[1]`

Name of the Splunk Enterprise service that needs to be restarted after files
are updated, not applicable when running in agent mode.

Default value: `$splunk::params::enterprise_service`

##### <a name="-splunk--enterprise--password--seed--mode"></a>`mode`

Data type: `Enum['agent', 'bolt']`

The class is designed to work in two ways, as a helper that is called by
Class[splunk::enterprise::config] or leveraged independently from with in a
Bolt Plan. The value defaults to "bolt" implicitly assuming that anytime it
is used outside of Class[splunk::enterprise::config], it is being used by
Bolt

Default value: `'bolt'`

##### <a name="-splunk--enterprise--password--seed--splunk_user"></a>`splunk_user`

Data type: `String[1]`



Default value: `$splunk::params::splunk_user`

### <a name="splunk--enterprise--service"></a>`splunk::enterprise::service`

Private class declared by Class[splunk::enterprise] to define a service
as its understood by Puppet using a dynamic set of data or platform specific
sub-classes

### <a name="splunk--enterprise--service--nix"></a>`splunk::enterprise::service::nix`

Private class declared by Class[splunk::enterprise::service] to provide
platform specific service management on Linux or Unix type systems.

### <a name="splunk--forwarder"></a>`splunk::forwarder`

Install and configure an instance of Splunk Universal Forwarder

#### Examples

##### Basic usage

```puppet
include splunk::forwarder
```

##### Install specific version and build with admin passord management

```puppet
class { 'splunk::params':
  version => '7.2.5',
  build   => '088f49762779',
}
class { 'splunk::forwarder':
  package_ensure => latest,
  manage_password => true,
}
```

#### Parameters

The following parameters are available in the `splunk::forwarder` class:

* [`server`](#-splunk--forwarder--server)
* [`version`](#-splunk--forwarder--version)
* [`package_name`](#-splunk--forwarder--package_name)
* [`package_ensure`](#-splunk--forwarder--package_ensure)
* [`staging_dir`](#-splunk--forwarder--staging_dir)
* [`path_delimiter`](#-splunk--forwarder--path_delimiter)
* [`forwarder_package_src`](#-splunk--forwarder--forwarder_package_src)
* [`package_provider`](#-splunk--forwarder--package_provider)
* [`manage_package_source`](#-splunk--forwarder--manage_package_source)
* [`package_source`](#-splunk--forwarder--package_source)
* [`install_options`](#-splunk--forwarder--install_options)
* [`splunk_user`](#-splunk--forwarder--splunk_user)
* [`forwarder_homedir`](#-splunk--forwarder--forwarder_homedir)
* [`forwarder_confdir`](#-splunk--forwarder--forwarder_confdir)
* [`service_name`](#-splunk--forwarder--service_name)
* [`service_file`](#-splunk--forwarder--service_file)
* [`boot_start`](#-splunk--forwarder--boot_start)
* [`use_default_config`](#-splunk--forwarder--use_default_config)
* [`splunkd_listen`](#-splunk--forwarder--splunkd_listen)
* [`splunkd_port`](#-splunk--forwarder--splunkd_port)
* [`logging_port`](#-splunk--forwarder--logging_port)
* [`purge_inputs`](#-splunk--forwarder--purge_inputs)
* [`purge_outputs`](#-splunk--forwarder--purge_outputs)
* [`purge_props`](#-splunk--forwarder--purge_props)
* [`purge_transforms`](#-splunk--forwarder--purge_transforms)
* [`purge_web`](#-splunk--forwarder--purge_web)
* [`forwarder_input`](#-splunk--forwarder--forwarder_input)
* [`forwarder_output`](#-splunk--forwarder--forwarder_output)
* [`manage_password`](#-splunk--forwarder--manage_password)
* [`seed_password`](#-splunk--forwarder--seed_password)
* [`reset_seeded_password`](#-splunk--forwarder--reset_seeded_password)
* [`password_config_file`](#-splunk--forwarder--password_config_file)
* [`seed_config_file`](#-splunk--forwarder--seed_config_file)
* [`seed_user`](#-splunk--forwarder--seed_user)
* [`password_content`](#-splunk--forwarder--password_content)
* [`password_hash`](#-splunk--forwarder--password_hash)
* [`secret_file`](#-splunk--forwarder--secret_file)
* [`secret`](#-splunk--forwarder--secret)
* [`addons`](#-splunk--forwarder--addons)
* [`allow_insecure`](#-splunk--forwarder--allow_insecure)
* [`purge_deploymentclient`](#-splunk--forwarder--purge_deploymentclient)

##### <a name="-splunk--forwarder--server"></a>`server`

Data type: `String[1]`

The fqdn or IP address of the Splunk server.

Default value: `$splunk::params::server`

##### <a name="-splunk--forwarder--version"></a>`version`

Data type: `String[1]`

Specifies the version of Splunk Forwarder the module should install and
manage.

Default value: `$splunk::params::version`

##### <a name="-splunk--forwarder--package_name"></a>`package_name`

Data type: `String[1]`

The name of the package(s) Puppet will use to install Splunk Forwarder.

Default value: `$splunk::params::forwarder_package_name`

##### <a name="-splunk--forwarder--package_ensure"></a>`package_ensure`

Data type: `String[1]`

Ensure parameter which will get passed to the Splunk package resource.

Default value: `$splunk::params::forwarder_package_ensure`

##### <a name="-splunk--forwarder--staging_dir"></a>`staging_dir`

Data type: `String[1]`

Root of the archive path to host the Splunk package.

Default value: `$splunk::params::staging_dir`

##### <a name="-splunk--forwarder--path_delimiter"></a>`path_delimiter`

Data type: `String[1]`

The path separator used in the archived path of the Splunk package.

Default value: `$splunk::params::path_delimiter`

##### <a name="-splunk--forwarder--forwarder_package_src"></a>`forwarder_package_src`

Data type: `String[1]`

The source URL for the splunk installation media (typically an RPM, MSI,
etc). If a `$src_root` parameter is set in splunk::params, this will be
automatically supplied. Otherwise it is required. The URL can be of any
protocol supported by the puppet/archive module. On Windows, this can be
a UNC path to the MSI.

Default value: `$splunk::params::forwarder_package_src`

##### <a name="-splunk--forwarder--package_provider"></a>`package_provider`

Data type: `Optional[String[1]]`

The package management system used to host the Splunk packages.

Default value: `$splunk::params::package_provider`

##### <a name="-splunk--forwarder--manage_package_source"></a>`manage_package_source`

Data type: `Boolean`

Whether or not to use the supplied `forwarder_package_src` param.

Default value: `true`

##### <a name="-splunk--forwarder--package_source"></a>`package_source`

Data type: `Optional[String[1]]`

*Optional* The source URL for the splunk installation media (typically an RPM,
MSI, etc). If `enterprise_package_src` parameter is set in splunk::params and
`manage_package_source` is true, this will be automatically supplied. Otherwise
it is required. The URL can be of any protocol supported by the puppet/archive
module. On Windows, this can be a UNC path to the MSI.

Default value: `undef`

##### <a name="-splunk--forwarder--install_options"></a>`install_options`

Data type: `Splunk::Fwdinstalloptions`

This variable is passed to the package resources' *install_options* parameter.

Default value: `$splunk::params::forwarder_install_options`

##### <a name="-splunk--forwarder--splunk_user"></a>`splunk_user`

Data type: `String[1]`

The user to run Splunk as.

Default value:

```puppet
versioncmp($version, '9.1.0') ? {
    -1 => $splunk::params::splunk_user,
    default => 'splunkfwd'
```

##### <a name="-splunk--forwarder--forwarder_homedir"></a>`forwarder_homedir`

Data type: `Stdlib::Absolutepath`

Specifies the Splunk Forwarder home directory.

Default value: `$splunk::params::forwarder_homedir`

##### <a name="-splunk--forwarder--forwarder_confdir"></a>`forwarder_confdir`

Data type: `Stdlib::Absolutepath`

Specifies the Splunk Forwarder configuration directory.

Default value: `$splunk::params::forwarder_confdir`

##### <a name="-splunk--forwarder--service_name"></a>`service_name`

Data type: `String[1]`

The name of the Splunk Forwarder service.

Default value: `$splunk::params::forwarder_service`

##### <a name="-splunk--forwarder--service_file"></a>`service_file`

Data type: `Stdlib::Absolutepath`

The path to the Splunk Forwarder service file.

Default value: `$splunk::params::forwarder_service_file`

##### <a name="-splunk--forwarder--boot_start"></a>`boot_start`

Data type: `Boolean`

Whether or not to enable splunk boot-start, which generates a service file to
manage the Splunk Forwarder service.

Default value: `$splunk::params::boot_start`

##### <a name="-splunk--forwarder--use_default_config"></a>`use_default_config`

Data type: `Boolean`

Whether or not the module should manage a default set of Splunk Forwarder
configuration parameters.

Default value: `true`

##### <a name="-splunk--forwarder--splunkd_listen"></a>`splunkd_listen`

Data type: `Stdlib::IP::Address`

The address on which splunkd should listen.

Default value: `'127.0.0.1'`

##### <a name="-splunk--forwarder--splunkd_port"></a>`splunkd_port`

Data type: `Stdlib::Port`

The management port for Splunk.

Default value: `$splunk::params::splunkd_port`

##### <a name="-splunk--forwarder--logging_port"></a>`logging_port`

Data type: `Stdlib::Port`

The port on which to send and listen for logs.

Default value: `$splunk::params::logging_port`

##### <a name="-splunk--forwarder--purge_inputs"></a>`purge_inputs`

Data type: `Boolean`

*Optional* If set to true, inputs.conf will be purged of configuration that is
no longer managed by the `splunkforwarder_input` type.

Default value: `false`

##### <a name="-splunk--forwarder--purge_outputs"></a>`purge_outputs`

Data type: `Boolean`

*Optional* If set to true, outputs.conf will be purged of configuration that is
no longer managed by the `splunk_output` type.

Default value: `false`

##### <a name="-splunk--forwarder--purge_props"></a>`purge_props`

Data type: `Boolean`

*Optional* If set to true, props.conf will be purged of configuration that is
no longer managed by the `splunk_props` type.

Default value: `false`

##### <a name="-splunk--forwarder--purge_transforms"></a>`purge_transforms`

Data type: `Boolean`

*Optional* If set to true, transforms.conf will be purged of configuration that is
no longer managed by the `splunk_transforms` type.

Default value: `false`

##### <a name="-splunk--forwarder--purge_web"></a>`purge_web`

Data type: `Boolean`

*Optional* If set to true, web.conf will be purged of configuration that is
no longer managed by the `splunk_web` type.

Default value: `false`

##### <a name="-splunk--forwarder--forwarder_input"></a>`forwarder_input`

Data type: `Hash`

Used to override the default `forwarder_input` type defined in splunk::params.

Default value: `$splunk::params::forwarder_input`

##### <a name="-splunk--forwarder--forwarder_output"></a>`forwarder_output`

Data type: `Hash`

Used to override the default `forwarder_output` type defined in splunk::params.

Default value: `$splunk::params::forwarder_output`

##### <a name="-splunk--forwarder--manage_password"></a>`manage_password`

Data type: `Boolean`

If set to true, Manage the contents of splunk.secret and passwd.

Default value: `$splunk::params::manage_password`

##### <a name="-splunk--forwarder--seed_password"></a>`seed_password`

Data type: `Boolean`

If set to true, Manage the contents of splunk.secret and user-seed.conf.

Default value: `$splunk::params::seed_password`

##### <a name="-splunk--forwarder--reset_seeded_password"></a>`reset_seeded_password`

Data type: `Boolean`

If set to true, deletes `password_config_file` to trigger Splunk's password
import process on restart of the Splunk services.

Default value: `$splunk::params::reset_seeded_password`

##### <a name="-splunk--forwarder--password_config_file"></a>`password_config_file`

Data type: `Stdlib::Absolutepath`

Which file to put the password in i.e. in linux it would be
`/opt/splunkforwarder/etc/passwd`.

Default value: `$splunk::params::forwarder_password_config_file`

##### <a name="-splunk--forwarder--seed_config_file"></a>`seed_config_file`

Data type: `Stdlib::Absolutepath`

Which file to place the admin password hash in so its imported by Splunk on
restart.

Default value: `$splunk::params::forwarder_seed_config_file`

##### <a name="-splunk--forwarder--seed_user"></a>`seed_user`

Data type: `String[1]`

The local user (usually 'admin') imported by Splunk.

Default value: `$splunk::params::seed_user`

##### <a name="-splunk--forwarder--password_content"></a>`password_content`

Data type: `String[1]`

The hashed password username/details for the user.

Default value: `$splunk::params::password_content`

##### <a name="-splunk--forwarder--password_hash"></a>`password_hash`

Data type: `String[1]`

The hashed password for the admin user.

Default value: `$splunk::params::password_hash`

##### <a name="-splunk--forwarder--secret_file"></a>`secret_file`

Data type: `Stdlib::Absolutepath`

Which file we should put the secret in.

Default value: `$splunk::params::forwarder_secret_file`

##### <a name="-splunk--forwarder--secret"></a>`secret`

Data type: `String[1]`

The secret used to salt the splunk password.

Default value: `$splunk::params::secret`

##### <a name="-splunk--forwarder--addons"></a>`addons`

Data type: `Hash`

Manage a splunk addons, see `splunk::addons`.

Default value: `{}`

##### <a name="-splunk--forwarder--allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

Disable certificate verification when connecting to SSL hosts to download packages.

Default value: `$splunk::params::allow_insecure`

##### <a name="-splunk--forwarder--purge_deploymentclient"></a>`purge_deploymentclient`

Data type: `Boolean`



Default value: `false`

### <a name="splunk--forwarder--config"></a>`splunk::forwarder::config`

Private class declared by Class[splunk::forwarder] to contain all the
configuration needed for a base install of the Splunk Universal
Forwarder

### <a name="splunk--forwarder--install"></a>`splunk::forwarder::install`

Private class declared by Class[splunk::forwarder] to contain or define
through additional platform specific sub-class, the required steps
for successfully installing the Splunk Universal Forwarder

### <a name="splunk--forwarder--password--manage"></a>`splunk::forwarder::password::manage`

Implements the direct management of the Splunk Forwarder admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans.

Note: Entirely done to make this implementation consistent with the method
used to manage admin password seeding.

#### Parameters

The following parameters are available in the `splunk::forwarder::password::manage` class:

* [`manage_password`](#-splunk--forwarder--password--manage--manage_password)
* [`password_config_file`](#-splunk--forwarder--password--manage--password_config_file)
* [`password_content`](#-splunk--forwarder--password--manage--password_content)
* [`secret_file`](#-splunk--forwarder--password--manage--secret_file)
* [`secret`](#-splunk--forwarder--password--manage--secret)
* [`service`](#-splunk--forwarder--password--manage--service)
* [`mode`](#-splunk--forwarder--password--manage--mode)
* [`splunk_user`](#-splunk--forwarder--password--manage--splunk_user)

##### <a name="-splunk--forwarder--password--manage--manage_password"></a>`manage_password`

Data type: `Boolean`

If set to true, Manage the contents of splunk.secret and passwd.

Default value: `$splunk::params::manage_password`

##### <a name="-splunk--forwarder--password--manage--password_config_file"></a>`password_config_file`

Data type: `Stdlib::Absolutepath`

Which file to put the password in i.e. in linux it would be
`/opt/splunkforwarder/etc/passwd`.

Default value: `$splunk::params::enterprise_password_config_file`

##### <a name="-splunk--forwarder--password--manage--password_content"></a>`password_content`

Data type: `String[1]`

The hashed password username/details for the user.

Default value: `$splunk::params::password_content`

##### <a name="-splunk--forwarder--password--manage--secret_file"></a>`secret_file`

Data type: `Stdlib::Absolutepath`

Which file we should put the secret in.

Default value: `$splunk::params::enterprise_secret_file`

##### <a name="-splunk--forwarder--password--manage--secret"></a>`secret`

Data type: `String[1]`

The secret used to salt the splunk password.

Default value: `$splunk::params::secret`

##### <a name="-splunk--forwarder--password--manage--service"></a>`service`

Data type: `String[1]`

Name of the Splunk Enterprise service that needs to be restarted after files
are updated, not applicable when running in agent mode.

Default value: `$splunk::params::forwarder_service`

##### <a name="-splunk--forwarder--password--manage--mode"></a>`mode`

Data type: `Enum['agent', 'bolt']`

The class is designed to work in two ways, as a helper that is called by
Class[splunk::forwarder::config] or leveraged independently from with in a
Bolt Plan. The value defaults to "bolt" implicitly assuming that anytime it
is used outside of Class[splunk::forwarder::config], it is being used by
Bolt

Default value: `'bolt'`

##### <a name="-splunk--forwarder--password--manage--splunk_user"></a>`splunk_user`

Data type: `String[1]`



Default value: `$splunk::params::splunk_user`

### <a name="splunk--forwarder--password--seed"></a>`splunk::forwarder::password::seed`

Implements the seeding and reseeding of the Splunk Forwarder admin password
so it can be used outside of regular management of the whole stack to
facilitate admin password resets through Bolt Plans

#### Parameters

The following parameters are available in the `splunk::forwarder::password::seed` class:

* [`reset_seeded_password`](#-splunk--forwarder--password--seed--reset_seeded_password)
* [`password_config_file`](#-splunk--forwarder--password--seed--password_config_file)
* [`seed_config_file`](#-splunk--forwarder--password--seed--seed_config_file)
* [`seed_user`](#-splunk--forwarder--password--seed--seed_user)
* [`password_hash`](#-splunk--forwarder--password--seed--password_hash)
* [`secret_file`](#-splunk--forwarder--password--seed--secret_file)
* [`secret`](#-splunk--forwarder--password--seed--secret)
* [`service`](#-splunk--forwarder--password--seed--service)
* [`mode`](#-splunk--forwarder--password--seed--mode)
* [`splunk_user`](#-splunk--forwarder--password--seed--splunk_user)

##### <a name="-splunk--forwarder--password--seed--reset_seeded_password"></a>`reset_seeded_password`

Data type: `Boolean`

If set to true, deletes `password_config_file` to trigger Splunk's password
import process on restart of the Splunk services.

Default value: `$splunk::params::reset_seeded_password`

##### <a name="-splunk--forwarder--password--seed--password_config_file"></a>`password_config_file`

Data type: `Stdlib::Absolutepath`

Which file to put the password in i.e. in linux it would be
`/opt/splunkforwarder/etc/passwd`.

Default value: `$splunk::params::forwarder_password_config_file`

##### <a name="-splunk--forwarder--password--seed--seed_config_file"></a>`seed_config_file`

Data type: `Stdlib::Absolutepath`

Which file to place the admin password hash in so its imported by Splunk on
restart.

Default value: `$splunk::params::forwarder_seed_config_file`

##### <a name="-splunk--forwarder--password--seed--seed_user"></a>`seed_user`

Data type: `String[1]`

The local user (usually 'admin') imported by Splunk.

Default value: `$splunk::params::seed_user`

##### <a name="-splunk--forwarder--password--seed--password_hash"></a>`password_hash`

Data type: `String[1]`

The hashed password for the admin user.

Default value: `$splunk::params::password_hash`

##### <a name="-splunk--forwarder--password--seed--secret_file"></a>`secret_file`

Data type: `Stdlib::Absolutepath`

Which file we should put the secret in.

Default value: `$splunk::params::forwarder_secret_file`

##### <a name="-splunk--forwarder--password--seed--secret"></a>`secret`

Data type: `String[1]`

The secret used to salt the splunk password.

Default value: `$splunk::params::secret`

##### <a name="-splunk--forwarder--password--seed--service"></a>`service`

Data type: `String[1]`

Name of the Splunk Forwarder service that needs to be restarted after files
are updated, not applicable when running in agent mode.

Default value: `$splunk::params::forwarder_service`

##### <a name="-splunk--forwarder--password--seed--mode"></a>`mode`

Data type: `Enum['agent', 'bolt']`

The class is designed to work in two ways, as a helper that is called by
Class[splunk::forwarder::config] or leveraged independently from with in a
Bolt Plan. The value defaults to "bolt" implicitly assuming that anytime it
is used outside of Class[splunk::forwarder::config], it is being used by
Bolt

Default value: `'bolt'`

##### <a name="-splunk--forwarder--password--seed--splunk_user"></a>`splunk_user`

Data type: `String[1]`



Default value: `$splunk::params::splunk_user`

### <a name="splunk--forwarder--service"></a>`splunk::forwarder::service`

Private class declared by Class[splunk::forwarder] to define a service as
its understood by Puppet using a dynamic set of data or platform specific
sub-classes

### <a name="splunk--forwarder--service--nix"></a>`splunk::forwarder::service::nix`

Private class declared by Class[splunk::forwarder::service] to provide
platform specific service management on Linux or Unix type systems.

### <a name="splunk--params"></a>`splunk::params`

This class takes a small number of arguments (can be set through Hiera) and
generates sane default values installation media names and locations.
Default ports can also be specified here. This is a parameters class, and
contributes no resources to the graph. Rather, it only sets values for
parameters to be consumed by child classes.

#### Parameters

The following parameters are available in the `splunk::params` class:

* [`version`](#-splunk--params--version)
* [`build`](#-splunk--params--build)
* [`splunkd_port`](#-splunk--params--splunkd_port)
* [`logging_port`](#-splunk--params--logging_port)
* [`server`](#-splunk--params--server)
* [`splunk_user`](#-splunk--params--splunk_user)
* [`src_root`](#-splunk--params--src_root)
* [`boot_start`](#-splunk--params--boot_start)
* [`forwarder_installdir`](#-splunk--params--forwarder_installdir)
* [`enterprise_installdir`](#-splunk--params--enterprise_installdir)
* [`default_host`](#-splunk--params--default_host)
* [`manage_net_tools`](#-splunk--params--manage_net_tools)
* [`allow_insecure`](#-splunk--params--allow_insecure)

##### <a name="-splunk--params--version"></a>`version`

Data type: `String[1]`

The version of Splunk to install. This will be in the form x.y.z; e.g.
"4.3.2".

Default value: `'9.2.0.1'`

##### <a name="-splunk--params--build"></a>`build`

Data type: `String[1]`

Splunk packages are typically named based on the platform, architecture,
version, and build. Puppet can determine the platform information
automatically but a build number must be supplied in order to correctly
construct the path to the packages. A build number will be six digits;
e.g. "123586".

Default value: `'d8ae995bf219'`

##### <a name="-splunk--params--splunkd_port"></a>`splunkd_port`

Data type: `Stdlib::Port`

The splunkd port.

Default value: `8089`

##### <a name="-splunk--params--logging_port"></a>`logging_port`

Data type: `Stdlib::Port`

The port on which to send logs, and listen for logs.

Default value: `9997`

##### <a name="-splunk--params--server"></a>`server`

Data type: `String[1]`

Optional fqdn or IP of the Splunk Enterprise server.  Used for setting up
the default TCP output and input.

Default value: `'splunk'`

##### <a name="-splunk--params--splunk_user"></a>`splunk_user`

Data type: `String[1]`

The user that splunk runs as.

Default value:

```puppet
$facts['os']['family'] ? {
    'windows' => 'Administrator',
    default => versioncmp($version, '8.0.0') ? { -1 => 'root', default => 'splunk'
```

##### <a name="-splunk--params--src_root"></a>`src_root`

Data type: `String[1]`

The root URL at which to find the splunk packages. The sane-default logic
assumes that the packages are located under this URL in the same way that
they are placed on download.splunk.com. The URL can be any protocol that
the puppet/archive module supports. This includes both puppet:// and
http://.

The expected directory structure is:

```
$root_url/
└── products/
    ├── universalforwarder/
    │   └── releases/
    |       └── $version/
    |           └── $platform/
    |               └── splunkforwarder-${version}-${build}-${additl}
    └── splunk/
        └── releases/
            └── $version/
                └── $platform/
                    └── splunk-${version}-${build}-${additl}
```

A semi-populated example of `src_root` contains:

```
$root_url/
└── products/
    ├── universalforwarder/
    │   └── releases/
    |       └── 7.2.4.2/
    |           ├── linux/
    |           |   ├── splunkforwarder-7.2.4.2-fb30470262e3-linux-2.6-amd64.deb
    |           |   ├── splunkforwarder-7.2.4.2-fb30470262e3-linux-2.6-intel.deb
    |           |   └── splunkforwarder-7.2.4.2-fb30470262e3-linux-2.6-x86_64.rpm
    |           ├── solaris/
    |           └── windows/
    |               └── splunkforwarder-7.2.4.2-fb30470262e3-x64-release.msi
    └── splunk/
        └── releases/
            └── 7.2.4.2/
                └── linux/
                    ├── splunk-7.2.4.2-fb30470262e3-linux-2.6-amd64.deb
                    ├── splunk-7.2.4.2-fb30470262e3-linux-2.6-intel.deb
                    └── splunk-7.2.4.2-fb30470262e3-linux-2.6-x86_64.rpm
```

Default value: `'https://download.splunk.com'`

##### <a name="-splunk--params--boot_start"></a>`boot_start`

Data type: `Boolean`

Enable Splunk to start at boot, create a system service file.

WARNING: Toggling `boot_start` from `false` to `true` will cause a restart of
Splunk Enterprise and Forwarder services.

Default value: `true`

##### <a name="-splunk--params--forwarder_installdir"></a>`forwarder_installdir`

Data type: `Optional[String[1]]`

Optional directory in which to install and manage Splunk Forwarder

Default value: `undef`

##### <a name="-splunk--params--enterprise_installdir"></a>`enterprise_installdir`

Data type: `Optional[String[1]]`

Optional directory in which to install and manage Splunk Enterprise

Default value: `undef`

##### <a name="-splunk--params--default_host"></a>`default_host`

Data type: `String[1]`

The host property in inputs.conf. Defaults to the server's hostname.

Default value: `$facts['clientcert']`

##### <a name="-splunk--params--manage_net_tools"></a>`manage_net_tools`

Data type: `Boolean`

From Splunk 7.2.2+ the package `net-tools` is required to be installed on the system.
By default this module manages the resource Package[net-tools], if this resource is
already declared on your code base, you can disable this flag.

Default value: `true`

##### <a name="-splunk--params--allow_insecure"></a>`allow_insecure`

Data type: `Boolean`

Disable certificate verification when connecting to SSL hosts to download packages.

Default value: `false`

## Defined types

### <a name="splunk--addon"></a>`splunk::addon`

Defined type for deploying Splunk Add-ons and Apps from either OS packages
or via splunkbase compatible archives

* **See also**
  * https://docs.splunk.com/Documentation/AddOns/released/Overview/AboutSplunkadd-ons

#### Examples

##### Basic usage

```puppet
splunk::addon { 'Splunk_TA_nix':
  splunkbase_source => 'puppet:///modules/splunk_qd/addons/splunk-add-on-for-unix-and-linux_602.tgz',
  inputs            => {
    'monitor:///var/log'       => {
     'whitelist' => '(\.log|log$|messages|secure|auth|mesg$|cron$|acpid$|\.out)',
     'blacklist' => '(lastlog|anaconda\.syslog)',
     'disabled'  => 'false'
    },
    'script://./bin/uptime.sh' =>  {
      'disabled' => 'false',
      'interval' => '86400',
      'source' => 'Unix:Uptime',
      'sourcetype' => 'Unix:Uptime'
    }
  }
}
```

#### Parameters

The following parameters are available in the `splunk::addon` defined type:

* [`splunk_home`](#-splunk--addon--splunk_home)
* [`package_manage`](#-splunk--addon--package_manage)
* [`splunkbase_source`](#-splunk--addon--splunkbase_source)
* [`extract_command`](#-splunk--addon--extract_command)
* [`package_name`](#-splunk--addon--package_name)
* [`owner`](#-splunk--addon--owner)
* [`inputs`](#-splunk--addon--inputs)

##### <a name="-splunk--addon--splunk_home"></a>`splunk_home`

Data type: `Optional[Stdlib::Absolutepath]`

Overrides the default Splunk installation target values from Class[splunk::params]

Default value: `undef`

##### <a name="-splunk--addon--package_manage"></a>`package_manage`

Data type: `Boolean`

If a package should be installed as part of declaring a new instance of Splunk::Addon

Default value: `true`

##### <a name="-splunk--addon--splunkbase_source"></a>`splunkbase_source`

Data type: `Optional[String[1]]`

When set the add-on will be installed from a splunkbase compatible archive instead of OS packages

Default value: `undef`

##### <a name="-splunk--addon--extract_command"></a>`extract_command`

Data type: `Optional[String[1]]`

A 'extract_command' to pass to the 'archive' that extracts a splunkbase_source package (helpful for SPL files)

Default value: `undef`

##### <a name="-splunk--addon--package_name"></a>`package_name`

Data type: `Optional[String[1]]`

The OS package to install if you are not installing via splunk compatible archive

Default value: `undef`

##### <a name="-splunk--addon--owner"></a>`owner`

Data type: `String[1]`

The user that files are owned by when they are created as part of add-on installation

Default value: `'splunk'`

##### <a name="-splunk--addon--inputs"></a>`inputs`

Data type: `Hash`

A hash of inputs to be configured as part of add-on installation, alterntively you can also define splunk_input or splunkforwarder_input resouces seperately

Default value: `{}`

## Resource types

### <a name="splunk_alert_actions"></a>`splunk_alert_actions`

Manage splunk alert_actions settings in alert_actions.conf

#### Parameters

The following parameters are available in the `splunk_alert_actions` type.

* [`provider`](#-splunk_alert_actions--provider)

##### <a name="-splunk_alert_actions--provider"></a>`provider`

The specific backend to use for this `splunk_alert_actions` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunk_authentication"></a>`splunk_authentication`

Manage splunk authentication settings in authentication.conf

#### Parameters

The following parameters are available in the `splunk_authentication` type.

* [`provider`](#-splunk_authentication--provider)

##### <a name="-splunk_authentication--provider"></a>`provider`

The specific backend to use for this `splunk_authentication` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunk_authorize"></a>`splunk_authorize`

Manage splunk authorize settings in authorize.conf

#### Parameters

The following parameters are available in the `splunk_authorize` type.

* [`provider`](#-splunk_authorize--provider)

##### <a name="-splunk_authorize--provider"></a>`provider`

The specific backend to use for this `splunk_authorize` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_config"></a>`splunk_config`

splunk config

#### Parameters

The following parameters are available in the `splunk_config` type.

* [`forwarder_confdir`](#-splunk_config--forwarder_confdir)
* [`forwarder_installdir`](#-splunk_config--forwarder_installdir)
* [`name`](#-splunk_config--name)
* [`server_confdir`](#-splunk_config--server_confdir)
* [`server_installdir`](#-splunk_config--server_installdir)

##### <a name="-splunk_config--forwarder_confdir"></a>`forwarder_confdir`


##### <a name="-splunk_config--forwarder_installdir"></a>`forwarder_installdir`


##### <a name="-splunk_config--name"></a>`name`

namevar

splunk config

##### <a name="-splunk_config--server_confdir"></a>`server_confdir`


##### <a name="-splunk_config--server_installdir"></a>`server_installdir`


### <a name="splunk_deploymentclient"></a>`splunk_deploymentclient`

Manage splunk deploymentclient entries in deploymentclient.conf

#### Parameters

The following parameters are available in the `splunk_deploymentclient` type.

* [`provider`](#-splunk_deploymentclient--provider)

##### <a name="-splunk_deploymentclient--provider"></a>`provider`

The specific backend to use for this `splunk_deploymentclient` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunk_distsearch"></a>`splunk_distsearch`

Manage distsearch entries in distsearch.conf

#### Parameters

The following parameters are available in the `splunk_distsearch` type.

* [`provider`](#-splunk_distsearch--provider)

##### <a name="-splunk_distsearch--provider"></a>`provider`

The specific backend to use for this `splunk_distsearch` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_indexes"></a>`splunk_indexes`

Manage splunk index settings in indexes.conf

#### Parameters

The following parameters are available in the `splunk_indexes` type.

* [`provider`](#-splunk_indexes--provider)

##### <a name="-splunk_indexes--provider"></a>`provider`

The specific backend to use for this `splunk_indexes` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_input"></a>`splunk_input`

Manage splunk input settings in inputs.conf

#### Parameters

The following parameters are available in the `splunk_input` type.

* [`provider`](#-splunk_input--provider)

##### <a name="-splunk_input--provider"></a>`provider`

The specific backend to use for this `splunk_input` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_limits"></a>`splunk_limits`

Manage splunk limits settings in limits.conf

#### Parameters

The following parameters are available in the `splunk_limits` type.

* [`provider`](#-splunk_limits--provider)

##### <a name="-splunk_limits--provider"></a>`provider`

The specific backend to use for this `splunk_limits` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_metadata"></a>`splunk_metadata`

Manage metadata entries in {default,local}.meta

#### Parameters

The following parameters are available in the `splunk_metadata` type.

* [`provider`](#-splunk_metadata--provider)

##### <a name="-splunk_metadata--provider"></a>`provider`

The specific backend to use for this `splunk_metadata` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_output"></a>`splunk_output`

Manage splunk output settings in outputs.conf

#### Parameters

The following parameters are available in the `splunk_output` type.

* [`provider`](#-splunk_output--provider)

##### <a name="-splunk_output--provider"></a>`provider`

The specific backend to use for this `splunk_output` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_props"></a>`splunk_props`

Manage splunk prop settings in props.conf

#### Parameters

The following parameters are available in the `splunk_props` type.

* [`provider`](#-splunk_props--provider)

##### <a name="-splunk_props--provider"></a>`provider`

The specific backend to use for this `splunk_props` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_server"></a>`splunk_server`

Manage splunk server settings in server.conf

#### Parameters

The following parameters are available in the `splunk_server` type.

* [`provider`](#-splunk_server--provider)

##### <a name="-splunk_server--provider"></a>`provider`

The specific backend to use for this `splunk_server` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_serverclass"></a>`splunk_serverclass`

Manage splunk serverclass entries in serverclass.conf

#### Parameters

The following parameters are available in the `splunk_serverclass` type.

* [`provider`](#-splunk_serverclass--provider)

##### <a name="-splunk_serverclass--provider"></a>`provider`

The specific backend to use for this `splunk_serverclass` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_transforms"></a>`splunk_transforms`

Manage splunk transforms settings in transforms.conf

#### Parameters

The following parameters are available in the `splunk_transforms` type.

* [`provider`](#-splunk_transforms--provider)

##### <a name="-splunk_transforms--provider"></a>`provider`

The specific backend to use for this `splunk_transforms` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_uiprefs"></a>`splunk_uiprefs`

Manage splunk web ui settings in ui-prefs.conf

#### Parameters

The following parameters are available in the `splunk_uiprefs` type.

* [`provider`](#-splunk_uiprefs--provider)

##### <a name="-splunk_uiprefs--provider"></a>`provider`

The specific backend to use for this `splunk_uiprefs` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

### <a name="splunk_web"></a>`splunk_web`

Manage splunk web settings in web.conf

#### Parameters

The following parameters are available in the `splunk_web` type.

* [`provider`](#-splunk_web--provider)

##### <a name="-splunk_web--provider"></a>`provider`

The specific backend to use for this `splunk_web` resource. You will seldom need to specify this --- Puppet will usually
discover the appropriate provider for your platform.

### <a name="splunkforwarder_deploymentclient"></a>`splunkforwarder_deploymentclient`

Manage splunkforwarder deploymentclient entries in deploymentclient.conf

#### Parameters

The following parameters are available in the `splunkforwarder_deploymentclient` type.

* [`provider`](#-splunkforwarder_deploymentclient--provider)

##### <a name="-splunkforwarder_deploymentclient--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_deploymentclient` resource. You will seldom need to specify this
--- Puppet will usually discover the appropriate provider for your platform.

### <a name="splunkforwarder_input"></a>`splunkforwarder_input`

Manage splunkforwarder input settings in inputs.conf

#### Parameters

The following parameters are available in the `splunkforwarder_input` type.

* [`provider`](#-splunkforwarder_input--provider)

##### <a name="-splunkforwarder_input--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_input` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunkforwarder_limits"></a>`splunkforwarder_limits`

Manage splunkforwarder limit settings in limits.conf

#### Parameters

The following parameters are available in the `splunkforwarder_limits` type.

* [`provider`](#-splunkforwarder_limits--provider)

##### <a name="-splunkforwarder_limits--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_limits` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunkforwarder_output"></a>`splunkforwarder_output`

Manage splunkforwarder output settings in outputs.conf

#### Parameters

The following parameters are available in the `splunkforwarder_output` type.

* [`provider`](#-splunkforwarder_output--provider)

##### <a name="-splunkforwarder_output--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_output` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunkforwarder_props"></a>`splunkforwarder_props`

Manage splunkforwarder props settings in props.conf

#### Parameters

The following parameters are available in the `splunkforwarder_props` type.

* [`provider`](#-splunkforwarder_props--provider)

##### <a name="-splunkforwarder_props--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_props` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunkforwarder_server"></a>`splunkforwarder_server`

Manage splunkforwarder server settings in server.conf

#### Parameters

The following parameters are available in the `splunkforwarder_server` type.

* [`provider`](#-splunkforwarder_server--provider)

##### <a name="-splunkforwarder_server--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_server` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

### <a name="splunkforwarder_transforms"></a>`splunkforwarder_transforms`

Manage splunkforwarder transforms settings in transforms.conf

#### Parameters

The following parameters are available in the `splunkforwarder_transforms` type.

* [`provider`](#-splunkforwarder_transforms--provider)

##### <a name="-splunkforwarder_transforms--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_transforms` resource. You will seldom need to specify this ---
Puppet will usually discover the appropriate provider for your platform.

### <a name="splunkforwarder_web"></a>`splunkforwarder_web`

Manage splunkforwarder web settings in web.conf

#### Parameters

The following parameters are available in the `splunkforwarder_web` type.

* [`provider`](#-splunkforwarder_web--provider)

##### <a name="-splunkforwarder_web--provider"></a>`provider`

The specific backend to use for this `splunkforwarder_web` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

## Data types

### <a name="Splunk--Entinstalloptions"></a>`Splunk::Entinstalloptions`

The Splunk::Entinstalloptions data type.

Alias of `Variant[Tuple[Hash,Hash,String,3,default], Array[String[1]]]`

### <a name="Splunk--Fwdinstalloptions"></a>`Splunk::Fwdinstalloptions`

The Splunk::Fwdinstalloptions data type.

Alias of `Variant[Tuple[Hash,String,1,default], Array[String[1]]]`

